config/routes.rb
Whenever::Web.routes.draw do
  get '/', to: 'jobs#index', as: :jobs
  get 'job/:id/run', to: 'jobs#run', as: :run_job
  get 'log/:kind/clear', to: 'logs#clear', as: :clear_log
end

app/models/whenever/log.rb
module Whenever
  class Log
    attr_reader :kind

    def initialize kind, path
      @kind = kind
      @path = path
    end

    def name
      "#{@kind}_log"
    end

    def tail
      File.read(@path)
    end

    def clear
      File.write(@path, nil)
    end
  end
end

app/models/whenever/web_config.rb
module Whenever
  class WebConfig
    attr_accessor :schedule_file, :parent_controller, :layout

    def initialize
      @schedule_file     = 'config/schedule.rb'
      @parent_controller = 'Whenever::WebController'
      @layout            = 'admin_whenever'
    end

    def parent_controller
      @parent_controller.to_s.constantize
    end
  end
end

app/models/whenever/web_job.rb
require 'whenever/patches/job'

module Whenever
  class WebJob
    include ActionView::Helpers::DateHelper
    attr_reader :interval

    def initialize job, interval
      @job      = job
      @interval = interval
    end

    # delegate :output, :at, to: :@job

    def task
      @job[1][0].options[:task]
    end

    def description
      # @job.options.fetch(:description) { task }
      if @job[1][0].options[:description].present?
        @job[1][0].options[:description]
      else
        task
      end
    end

    def interval
      distance_of_time_in_words(@job[0])#.gsub('about', '')
    rescue ArgumentError
      @interval
    end

    def roles
      @job[1][0].roles.join(', ')
    end

    def at
      @job[1][0].at
    end

    def to
      @job[1][0].at
    end

    def output
      @job[1][0].options[:output]
    end

  end
end

app/models/whenever/web_job_list.rb
require 'whenever/patches/job_list'

module Whenever
  class WebJobList < JobList
    include Enumerable
    attr_reader :set_variables, :job_types

    delegate :fetch, :each, to: :web_jobs

    def web_jobs
      @web_jobs ||= begin
        @jobs.flat_map do |interval, jobs|
          jobs.map do |job|
            WebJob.new(job, interval)
          end
        end
      end
    end

    def logs
      @logs ||= fetch_logs(@set_variables[:output])
    end

    alias_method :old_job_type, :job_type

    def job_type name, template
      (@job_types ||= {})[name] = template
      old_job_type name, template
    end

    protected

    def fetch_logs path, kind = 'standard'
      case path
      when Hash
        path.map{ |k, v| fetch_logs(v, k) }.inject(:merge)
      when String
        { kind.to_s => Log.new(kind, path) }
      else
        {}
      end
    end
  end
end

app/controllers/whenever/jobs_controller.rb
module Whenever
  class JobsController < Web.config.parent_controller
    def index
      @crontab = CommandLine.new.send(:read_crontab)
    end

    def run
      runner = JobRunner.new(params[:id])
      runner.run
      redirect_to jobs_path, notice: t('.success', command: runner.command)
    end
  end
end

app/controllers/whenever/logs_controller.rb
module Whenever
  class LogsController < Web.config.parent_controller
    def clear
      log.clear
      redirect_to jobs_path, notice: t('.success', kind: log.kind)
    end

    protected

    def log
      @log ||= Web.job_list.logs.fetch(params[:kind])
    end
  end
end

app/controllers/whenever/web_controller.rb
module Whenever
  class WebController < ActionController::Base
    layout Web.config.layout
  end
end

app/helpers/whenever/jobs_helper.rb
module Whenever
  module JobsHelper
    def job_list
      @job_list ||= Web.job_list
    end

    def method_missing(method, *args, &block)
      main_app.send(method, *args, &block)
    rescue NoMethodError
      super
    end
  end
end

app/views/layouts/admin_whenever.html.erb
<html>
  <head>
    <title>Mirraw - Rake Tasks</title>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <%= stylesheet_link_tag 'admin', 'admin_style', media: 'all', 'data-turbolinks-track': 'reload' %>
  </head>
  <body class="nav-md">
    <div class=" container body">
      <div class="row">
        <div class="page-title">
          <div class="text-center">
            <h3>Mirraw - Rake Tasks</h3>
          </div>
        </div>

        <div class="clearfix"></div>

        <div class="row">
          <div class="col-xs-12">
            <div class="x_panel">
              <div class="x_content">
                <%= yield %>
              </div>
            </div>
          </div>
        </div>
      </div>
      <footer>
      </footer>
    </div>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </body>
</html>

app/views/whenever/jobs/index.html.erb
<div class="panel panel-default">
  <div class="panel-heading clearfix">
    <div class="panel-title pull-left">
      <%= t('whenever.cron_jobs') %>
    </div>
  </div>
  <table class="table" style="color:black">
    <thead>
      <tr>
        <th><%= t('whenever.task') %></th>
        <th><%= t('whenever.interval') %></th>
        <th><%= t('whenever.hour') %></th>
        <th><%= t('whenever.roles') %></th>
        <th><%= t('whenever.action') %></th>
      </tr>
    </thead>
    <tbody>
      <% job_list.each_with_index do |job, i| %>
      <tr>
        <td><%= job.description %></td>
        <td><%= job.interval %></td>
        <td><%= job.at %></td>
        <td><%= job.roles %></td>
        <td><%= link_to t('whenever.run_now'), run_job_path(i), class: 'btn btn-danger', title: job.output %></td>
      </tr>
      <% end %>
    </tbody>
  </table>
</div>
<% job_list.logs.each do |_, log| %>
<div class="panel panel-default">
  <div class="panel-heading clearfix">
    <div class="panel-title pull-left">
      <%= t("whenever.#{log.name}") %>
    </div>
    <div class="pull-right">
      <%= link_to t('whenever.clear'), clear_log_path(log.kind), class: 'btn btn-xs btn-warning' %>
    </div>
  </div>
  <%= text_area_tag(log.name, log.tail, rows: 15, class: 'form-control', disabled: 'disabled') %>
</div>
<script type="text/javascript">
  var <%= log.name %> = document.getElementById('<%= log.name %>');
  <%= log.name %>.scrollTop = <%= log.name %>.scrollHeight;
</script>
<% end %>
<div class="panel panel-default">
  <div class="panel-heading clearfix">
    <div class="panel-title pull-left">
      <%= t('whenever.options') %>
    </div>
  </div>
  <table class="table" style="color:black">
    <thead>
      <tr>
        <th><%= t('whenever.settings') %></th>
        <th></th>
      </tr>
    </thead>
    <tbody>
      <% job_list.set_variables.each do |k, v| %>
      <tr>
        <td><%= k %></td>
        <td><%= v %></td>
      </tr>
      <% end %>
    <thead>
      <tr>
        <th><%= t('whenever.job_types') %></th>
        <th></th>
      </tr>
    </thead>
      <% job_list.job_types.each do |k, v| %>
      <tr>
        <td><%= k %></td>
        <td><%= v %></td>
      </tr>
      <% end %>
    </tbody>
  </table>
</div>
<% if @crontab.present? %>
<div class="panel panel-default">
  <div class="panel-heading clearfix">
    <div class="panel-title pull-left">
      <%= t('whenever.cron_tab') %>
    </div>
  </div>
  <pre>
    <%= @crontab %>
  </pre>
</div>
<% end %>